/*
  
*/
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window

extern int NumberOfDays = 50;
extern string Begin_1 = "07:00";
extern string End_1 = "11:00";
extern color Color_1 = BlanchedAlmond;
extern string Begin_2 = "13:00";
extern string End_2 = "17:00";
extern color Color_2 = Lavender;
extern string Begin_3 = "19:00";
extern string End_3 = "23:00";
extern color Color_3 = MistyRose;
extern bool HighRange = FALSE;

void init() {
   DeleteObjects();
   for (int count_0 = 0; count_0 < NumberOfDays; count_0++) {
      CreateObjects("PWT1" + count_0, Color_1);
      CreateObjects("PWT2" + count_0, Color_2);
      CreateObjects("PWT3" + count_0, Color_3);
   }
   Comment("");
}

void deinit() {
   DeleteObjects();
   Comment("");
}

void CreateObjects(string A_name_0, color A_color_8) {
   ObjectCreate(A_name_0, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(A_name_0, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_8);
   ObjectSet(A_name_0, OBJPROP_BACK, TRUE);
}

void DeleteObjects() {
   for (int count_0 = 0; count_0 < NumberOfDays; count_0++) {
      ObjectDelete("PWT1" + count_0);
      ObjectDelete("PWT2" + count_0);
      ObjectDelete("PWT3" + count_0);
   }
}

void start() {
   int datetime_0 = TimeCurrent();
   for (int count_4 = 0; count_4 < NumberOfDays; count_4++) {
      DrawObjects(datetime_0, "PWT1" + count_4, Begin_1, End_1);
      DrawObjects(datetime_0, "PWT2" + count_4, Begin_2, End_2);
      DrawObjects(datetime_0, "PWT3" + count_4, Begin_3, End_3);
      for (datetime_0 = decDateTradeDay(datetime_0); TimeDayOfWeek(datetime_0) > 5; datetime_0 = decDateTradeDay(datetime_0)) {
      }
   }
}

void DrawObjects(int Ai_0, string A_name_4, string As_12, string As_20) {
   int str2time_28 = StrToTime(TimeToStr(Ai_0, TIME_DATE) + " " + As_12);
   int str2time_32 = StrToTime(TimeToStr(Ai_0, TIME_DATE) + " " + As_20);
   int shift_52 = iBarShift(NULL, 0, str2time_28);
   int shift_56 = iBarShift(NULL, 0, str2time_32);
   double high_36 = High[iHighest(NULL, 0, MODE_HIGH, shift_52 - shift_56, shift_56)];
   double Ld_44 = Low[iLowest(NULL, 0, MODE_LOW, shift_52 - shift_56, shift_56)];
   if (!HighRange) {
      high_36 = 0;
      Ld_44 = 2.0 * Ld_44;
   }
   ObjectSet(A_name_4, OBJPROP_TIME1, str2time_28);
   ObjectSet(A_name_4, OBJPROP_PRICE1, high_36);
   ObjectSet(A_name_4, OBJPROP_TIME2, str2time_32);
   ObjectSet(A_name_4, OBJPROP_PRICE2, Ld_44);
}

int decDateTradeDay(int Ai_0) {
   int Li_4 = TimeYear(Ai_0);
   int Li_8 = TimeMonth(Ai_0);
   int Li_12 = TimeDay(Ai_0);
   int hour_16 = TimeHour(Ai_0);
   int minute_20 = TimeMinute(Ai_0);
   Li_12--;
   if (Li_12 == 0) {
      Li_8--;
      if (Li_8 == 0) {
         Li_4--;
         Li_8 = 12;
      }
      if (Li_8 == 1 || Li_8 == 3 || Li_8 == 5 || Li_8 == 7 || Li_8 == 8 || Li_8 == 10 || Li_8 == 12) Li_12 = 31;
      if (Li_8 == 2) {
         if (MathMod(Li_4, 4) == 0.0) Li_12 = 29;
         else Li_12 = 28;
      }
      if (Li_8 == 4 || Li_8 == 6 || Li_8 == 9 || Li_8 == 11) Li_12 = 30;
   }
   return (StrToTime(Li_4 + "." + Li_8 + "." + Li_12 + " " + hour_16 + ":" + minute_20));
}
